/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_config.c 87 2009-01-25 15:14:17Z ertl-honda $
 */

/*
 * åȰ¸⥸塼MPCOREѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "mp.h"

/*
 *  SILΥԥåѿ
 */
uint32_t TOPPERS_spn_var;

/*
 *  str_ker() μ¹˥ޥץåΤ߼¹Ԥ
 */
void
chip_mprc_initialize(void)
{
	/*
	 *  DICν
	 */
	dic_init();

	/*
	 *  SCUν
	 */
	scu_init();

	/*
	 *  SILΥԥåѿν
	 */
	TOPPERS_spn_var = 0U;
}

/*
 *  åװ¸ν
 */
void
chip_initialize(void)
{
	/*
	 * ARM¸ν
	 */
	core_initialize();

	/*
	 * å̵
	 */
	mpcore_cache_disable();

	/*
	 * MMUͭ
	 */
	mpcore_mmu_init();

	/*
	 * SMP⡼ɤ
	 */
	mpcore_smp_mode_enable();

	/*
	 * åͭ
	 */
	mpcore_cache_enable();

	/*
	 * DICCPU󥿥ե
	 */
	dic_cpu_init();
}

/*
 *  åװ¸νλ
 */
void
chip_exit(void)
{
	/*
	 *  ARM¸νλ
	 */
	core_terminate();

	/*
	 *  DICCPU󥿥ե
	 */
	dic_cpu_stop();

	/*
	 *  DICDIS󥿥ե
	 */
	if (x_sense_mprc()) {
		dic_stop();
	}
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask)
{
	assert(VALID_INTNO(intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  ׵Υޥ
	 *
	 *  ߤդޤޡ٥ȥꥬåȥꥬ䡤
	 *  ͥ٤ԤΤϴʤᡤ°ˤ餺
	 *  öޥ롥
	 */    
	x_disable_int(intno);

	/*
	 * °
	 */
	if ((intatr & TA_EDGE) != 0U) {
		dic_config(INTNO_MASK(intno), DIC_ICR_EDGE);
		x_clear_int(intno);
	}
	else {
		dic_config(INTNO_MASK(intno), DIC_ICR_LEVEL);
	}

	/*
	 * ͥ٥ޥ
	 */
	dic_set_priority(INTNO_MASK(intno), INT_IPM(intpri));
	dic_set_target(INTNO_MASK(intno), (1 << x_prc_index()));

	/*
	 * ߤ
	 */
	if ((intatr & TA_ENAINT) != 0U) {
		(void)x_enable_int(intno);
	}
}

#ifndef OMIT_DEFAULT_INT_HANDLER

/*
 *  ̤γߤäν
 */
void
default_int_handler(void){
	ID prc_id = ID_PRC(x_prc_index());
	
	syslog_1(LOG_EMERG, "Processor %d : Unregistered Interrupt occurs.", prc_id);
	target_exit();
}

#endif /* OMIT_DEFAULT_INT_HANDLER */
