/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel  
 *
 *  Copyright (C) 2008-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.h 266 2009-05-14 06:32:27Z ertl-honda $
 */

/*
 *		ץå¸⥸塼Nios2ѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#include "nios2.h"

/*
 *  㳰θĿ
 */
#define TNUM_EXCH  32U

/*
 *  ߥϥɥֹ˴ؤ
 */ 
#define TMIN_INHNO 0U
#define TMAX_INHNO 31U
#define TNUM_INH   32U

/*
 *  ֹ˴ؤ
 */ 
#define TMIN_INTNO 0U
#define TMAX_INTNO 31U
#define TNUM_INT   32U

/*
 *  ͥ٤θĿ
 */
#define  TNUM_INT_PRI  8U

/*
 *  ֹΥޥʲ16bitΤߤͭ
 */
#define INTNO_MASK(intno) (intno & 0xffffU)

/*
 *  ߥϥɥֹΥޥʲ16bitΤߤͭ
 */
#define INHNO_MASK(intno) (intno & 0xffffU)

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno) (TMIN_INTNO <= (INTNO_MASK(intno)) && (INTNO_MASK(intno)) <= TMAX_INTNO)
#define VALID_INTNO_DISINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)	VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)   VALID_INTNO(intno)

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ޥץå֤
 */
/*
 * ޥץå֤
 */
Inline bool_t
x_sense_mprc(void)
{
	return (x_prc_index() == (TOPPERS_MASTER_PRCID - 1));
}

/*
 *  󥿥ƥѤΥåϥɥ쥹ޥ
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((int *)(istk) + (istksz)))

/*
 *  ץåü̿Υ饤ؿ
 */

/*
 *  åη
 */
#define TSKLOCK   uint32_t
#define OBJLOCK   uint32_t
#define POBJLOCK  uint32_t*
#define GLOCK   uint32_t

#if TTYPE_KLOCK == G_KLOCK

/*
 *  㥤ȥåνG_LOCKξ
 */
Inline void
x_initialize_giant_lock(GLOCK *p_giant_lock)
{
	*p_giant_lock = GIANT_LOCK;
	mutex_init(GIANT_LOCK);
}

/*
 *  㥤ȥåμ
 */
Inline bool_t
x_acquire_giant_lock(GLOCK *p_giant_lock)
{
	do{
		if (mutex_try_lock(GIANT_LOCK, x_prc_index())) {
			/* å */
			Asm("":::"memory");
			return false;
		}
	}while (current_ipending() == 0U);

	/* å  ߼ */
	return true;
}

#define t_acquire_giant_lock(p_giant_lock) x_acquire_giant_lock(p_giant_lock)
#define i_acquire_giant_lock(p_giant_lock) x_acquire_giant_lock(p_giant_lock)

/*
 *  㥤ȥåβ
 */
Inline void
x_release_giant_lock(GLOCK *p_giant_lock)
{
	Asm("":::"memory");
	mutex_unlock(GIANT_LOCK, x_prc_index());
}

#define t_release_giant_lock(p_giant_lock) x_release_giant_lock(p_giant_lock)
#define i_release_giant_lock(p_giant_lock) x_release_giant_lock(p_giant_lock)

#endif /* TTYPE_KLOCK == G_KLOCK */

#if TTYPE_KLOCK == P_KLOCK

/*
 *  åΥơ֥
 *  åȰ¸ 
 */
extern const uint32_t target_tsk_lock_table[];

/*
 *  åνP_LOCKξ
 */
Inline void
x_initialize_tsk_lock(TSKLOCK *p_tsk_lock)
{
	*p_tsk_lock = target_tsk_lock_table[x_prc_index()];
	mutex_init(*p_tsk_lock);
}

/*
 *  åμ
 */
Inline bool_t
x_acquire_tsk_lock(TSKLOCK *p_tsk_lock)
{
	do{
		if (mutex_try_lock(*p_tsk_lock, x_prc_index())) {
			/* å */
			Asm("":::"memory");
			return false;
		}
	}while (current_ipending() == 0U);

	/* å  ߼ */
	return true;
}

#define t_acquire_tsk_lock(p_tsk_lock)  x_acquire_tsk_lock(p_tsk_lock)
#define i_acquire_tsk_lock(p_tsk_lock)  x_acquire_tsk_lock(p_tsk_lock)

/*
 *  åβ
 */
Inline void
x_release_tsk_lock(TSKLOCK *p_tsk_lock)
{
	Asm("":::"memory");
	mutex_unlock(*p_tsk_lock, x_prc_index());
}

#define t_release_tsk_lock(p_tsk_lock) x_release_tsk_lock(p_tsk_lock)
#define i_release_tsk_lock(p_tsk_lock) x_release_tsk_lock(p_tsk_lock)

/*
 *  ֥åΥơ֥
 *  åȰ¸ 
 */
extern const uint32_t target_obj_lock_table[];

/*
 *  ֥ȥåν
 */
Inline void
x_initialize_obj_lock(OBJLOCK *p_obj_lock)
{
	*p_obj_lock = target_obj_lock_table[x_prc_index()];
	mutex_init(*p_obj_lock);
}

/*
 *  ֥ȥåμ
 */
Inline bool_t
x_acquire_obj_lock(OBJLOCK *p_obj_lock)
{
	do{
		if (mutex_try_lock(*p_obj_lock, x_prc_index())) {
			/* å */
			Asm("":::"memory");
			return false;
		}
	}while (current_ipending() == 0U);

	/* å  ߼ */
	return true;
}

#define t_acquire_obj_lock(p_obj_lock) x_acquire_obj_lock(p_obj_lock)
#define i_acquire_obj_lock(p_obj_lock) x_acquire_obj_lock(p_obj_lock)

/*
 *  ֥ȥåβ
 */
Inline void
x_release_obj_lock(OBJLOCK *p_obj_lock)
{
	Asm("":::"memory");
	mutex_unlock(*p_obj_lock, x_prc_index());
}

#define t_release_obj_lock(p_obj_lock) x_release_obj_lock(p_obj_lock)
#define i_release_obj_lock(p_obj_lock) x_release_obj_lock(p_obj_lock)

#endif /* TTYPE_KLOCK == P_KLOCK */

/*
 *  Nios2ץåȥ֥å
 */
typedef struct nios2_prc_control_block{
	/*
	 * 㳰ʳ/CPU㳰ˤΥͥȲΥ
	 */
	uint32_t except_nest_count;

	/*
	 * Ƴߤγ׵ػߥե饰ξ
	 */
	uint32_t idf;

	/*
	 *  ߤγͥ٥ޥ͡ɽ
	 */
	uint8_t iipm;

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	uint32_t	bitpat_cfgint;
}NPCB;

/*
 *  NPCBؤΥơ֥
 */
extern NPCB* const p_npcb_table[];

/*
 *  ץå NPCB ؤΥ
 */
#define my_npcb (p_npcb_table[x_prc_index()])

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  ͥγߤߤʤ
 */

/*
 *  ƥȤλ
 *
 *   㳰ʳ/CPU㳰ˤΥͥȲ򥫥Ȥѿexcept_nest_countˤ
 *   Ѱդ㳰ǥ󥯥Ȥ뤳ȤǡƥȤȽꤹ롥
 */
Inline bool_t
sense_context(void)
{
	return(my_npcb->except_nest_count > 0U);
}

/*
 *  CPUå֤ؤΰܹ
 */
Inline void
x_lock_cpu(void)
{
	set_status(current_status() & ~STATUS_PIE);
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
}

#define t_lock_cpu()   x_lock_cpu()
#define i_lock_cpu()   x_lock_cpu()

/*
 *  CPUå֤β
 */
Inline void
x_unlock_cpu(void)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
	set_status(current_status() | STATUS_PIE);
}

#define t_unlock_cpu() x_unlock_cpu()
#define i_unlock_cpu() x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
	return((current_status() & STATUS_PIE) == 0U);
}

#define t_sense_lock() x_sense_lock()
#define i_sense_lock() x_sense_lock()

/*
 *  ߥϥɥϿѥơ֥
 *   ֤ϥե졼
 */
extern const FP inh_table[TNUM_INH];

/*
 *  ߥϥɥ
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry, uint_t affinity_mask)
{
}

/*
 *  ߥϥɥνޥ
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)

/*
 *  ͥ٥ޥ饤֥
 *
 *  XPS Interrupt Controller ϳͥ٤γǰʤᡤ
 *  եȥǵŪ˼¸롥 
 */
extern const uint32_t* const p_iipm_mask_table[TNUM_PRC];

#define my_iipm_mask_table (p_iipm_mask_table[x_prc_index()])

/*
 *  IPMimp_mask_tableΥǥåѴޥ
 */
#define INDEX_IPM(ipm)  (-(ipm))

/*
 *  ͥ٥ޥγɽɽѴ
 *
 */
#define EXT_IPM(iipm)    (-((PRI)(iipm)))       /* ɽɽ */
#define INT_IPM(ipm)     ((uint8_t)(-(ipm)))    /* ɽɽ */

/*
 *  (ǥ)ͥ٥ޥ
 * 
 *  ꤵ줿ͥ٤ꤵ줿׵ػߥե饰Υơ֥ͤȡʥ
 *  Ρ˳Ƴߤγ׵ػߥե饰ξ֤ݻѿͤȤ
 *  ORIRCγ׵ػߥե饰˥åȤꤷͥ٤ѿ
 *  ipm¸롥
 */
Inline void
x_set_ipm(PRI intpri)
{
	uint32_t ipm_mask = my_iipm_mask_table[INT_IPM(intpri)];
	my_npcb->iipm = INT_IPM(intpri);

	/*
	 *  XPS INTC γߥȥϥ֥͡쥸
	 *  ꥢ쥸뤿ᡤöƤγߤػߤƤ顤
	 *  γߤΤߵĤɬפ
	 */
	/* ߶ػ */
	set_ienable(0U);

	/* ޥꤵƤʤߤΤߵ */
	set_ienable(~(ipm_mask|my_npcb->idf));

	my_npcb->iipm = INT_IPM(intpri);
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 *
 *  ipm֤ͤ
 */
Inline PRI
x_get_ipm(void)
{
	return(EXT_IPM(my_npcb->iipm));
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥ޤʥǥΡ˳׵ػߥե饰idf
 *  ӥåȤ򥻥åȤ롥
 *  ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	if ((my_npcb->bitpat_cfgint & INTNO_BITPAT(INTNO_MASK(intno))) == 0U) {
		return(false);
	}

	my_npcb->idf |= INTNO_BITPAT(INTNO_MASK(intno));
	set_ienable(~(my_iipm_mask_table[my_npcb->iipm]|my_npcb->idf));

	return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/* 
 * (ǥ)׵ػߥե饰β
 *
 * ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 * Ĥ롥ޤʥǥΡ˳׵ػߥե饰idf
 * ӥåȤ򥯥ꥢ롥
 * ׵ޥ뵡ǽ򥵥ݡȤƤʤˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	if ((my_npcb->bitpat_cfgint & INTNO_BITPAT(INTNO_MASK(intno))) == 0U) {
		return(false);
	}

	my_npcb->idf &= ~INTNO_BITPAT(INTNO_MASK(intno));
	set_ienable(~(my_iipm_mask_table[my_npcb->iipm]|my_npcb->idf));

	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{

}

#define t_clear_int(intno) x_clear_int(intno) 
#define i_clear_int(intno) x_clear_int(intno) 


/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	return((current_ipending() & INTNO_BITPAT(INTNO_MASK(intno))) != 0);
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask);

/*
 *  ߥϥɥɬפIRC
 */
Inline void
i_begin_int(INTNO intno)
{
    
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{

}

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void *p_exinf);


/*
 *  CPU㳰ǽ
 */

/*
 *  CPU㳰ե졼Υեå
 */
#define CPUEXC_FLM_EXCNO   0x00U
#define CPUEXC_FLM_ESTATUS 0x01U
#define CPUEXC_FLM_NEST    0x02U
#define CPUEXC_FLM_PC      0x03U
#define CPUEXC_FLM_IPM     0x04U

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 */
Inline void
initialize_exception(void)
{
}

/*
 *  CPU㳰ȯΥƥ֤λ
 */

/*
 *  CPU㳰ȯΥƥȤλ
 *
 *  CPU㳰ȯΥƥȤƥȤλfalse
 *  Ǥʤtrue֤
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
	return((*(((uint32_t *)p_excinf) + CPUEXC_FLM_NEST) != 0U));
}

/*
 *  CPU㳰ȯ(ǥ)ͥ٥ޥλ
 */
Inline uint8_t
exc_get_ipm(void *p_excinf)
{
	return((uint8_t)(*(((uint32_t *)p_excinf) + CPUEXC_FLM_IPM)));
}

/*
 * CPU㳰ȯCPUå֤λ
 *
 *  CPUå֤ξtrueCPUå֤ξˤfalse֤
 */
Inline bool_t
exc_sense_lock(void *p_excinf)
{
	return((*(((uint32_t *)p_excinf) + CPUEXC_FLM_ESTATUS) & STATUS_PIE) != STATUS_PIE);
}

/*
 * ߥå֤
 */
Inline bool_t
exc_sense_int_lock(void *p_excinf)
{
	return false;
}

/*
 *  CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤʥ
 *  ǥΡ˳ͥ٥ޥ֤ǤtrueǤʤ
 *  false֤CPU㳰ͥγ߽ȯ
 *  ˤfalse֤ˡ
 *
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
	return(!exc_sense_context(p_excinf)
		   && (exc_get_ipm(p_excinf) == 0U)
		   && !exc_sense_lock(p_excinf)
		   && !exc_sense_int_lock(p_excinf));
}

/*
 *  CPU㳰ȯΥƥȤȳߡCPUå֤λ
 *
 *  CPU㳰ȯΥƥ֤ͥ¹Ǥʤ
 *  ƥȤǤꡤߥå֤ǤʤCPUå֤Ǥʤ
 *  trueǤʤfalse֤CPU㳰ͥγ߽
 *  ȯˤfalse֤ˡ
 *
 */
Inline bool_t
exc_sense_unlock(void *p_excinf)
{
	return(!exc_sense_context(p_excinf)
		   && !exc_sense_lock(p_excinf)
		   && !exc_sense_int_lock(p_excinf));
}

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void);

/*
 *  ̤㳰äν
 */
extern void default_exc_handler(void *p_excinf);

/*
 *  ǥѥå
 */

/*
 *  ǹ̥ͥؤΥǥѥåcore_support.S
 *
 *  dispatchϡƥȤƤӽФ줿ӥ
 *  ƤӽФ٤ΤǡƥȡCPUå֡ǥѥ
 *  ľ֡ʥǥΡ˳ͥ٥ޥ֤ǸƤӽФ
 *  Фʤʤ
 */
extern void dispatch(void);

/*
 *  Υޥ졼core_support.S
 */
extern void dispatch_and_migrate(ID prcid);

/*
 *  ߤΥƥȤΤƥޥ졼core_support.S
 */
extern void exit_and_migrate(ID prcid);

/*
 *  ǥѥåưϡcore_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *  ߤΥƥȤΤƤƥǥѥåcore_support.S
 *
 *  exit_and_dispatchϡext_tskƤӽФ٤Τǡƥ
 *  ȡCPUå֡ǥѥåľ֡ʥǥΡ˳ͥ
 *  ٥ޥ֤ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *  ͥνλθƽФcore_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} CTXB;
     
/*
 *  ƥȤν
 *
 *  ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *  ǥåΰȤäƤϤʤʤ
 *
 *  activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *  λǤTCBƤʤǤ롥
 */
extern void    start_r(void);

#define activate_context(p_tcb)                                         \
{                                                                       \
    (p_tcb)->tskctxb.sp = (void *)((char_t *)((p_tcb)->p_tinib->stk)    \
                                        + (p_tcb)->p_tinib->stksz);     \
    (p_tcb)->tskctxb.pc = (FP)start_r;                                  \
}

/*
 *  calltexϻѤʤ
 */
#define OMIT_CALLTEX

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
