/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*!
 *  \file   toppers/misc.hpp
 *  \brief  ¿ʥ饤֥Τ
 */
#ifndef TOPPERS_MISC_HPP_
#define TOPPERS_MISC_HPP_

#include <stdexcept>
#include <locale>
#include <iosfwd>
#include <string>
#include <algorithm>
#include <cctype>
#include <cwchar>
#include <cwctype>
#include <cstdlib>
#include "toppers/codeset.hpp"
#include <boost/scoped_array.hpp>

// workaround
#include <ctype.h>
#include <wctype.h>

#define TOPPERS_STRINGIFY( s )  TOPPERS_STRINGIFY_( s )
#define TOPPERS_STRINGIFY_( s ) # s

namespace toppers
{

  /*!
   *  \class  conversion_error misc.hpp "toppers/misc.hpp"
   *  \brief  Ѵ顼㳰饹
   */
  class conversion_error : public std::runtime_error
  {
  public:
    /*!
     *  \brief  󥹥ȥ饯
     *  \param  what  㳰ʸ
     */
    explicit conversion_error( std::string const& what ) : std::runtime_error( what ) {}
  };

  /*!
   *  \brief  󥰥Хʸ CharT ¿ wchar_t ʸؤѴ
   *  \param  ch  󥰥Хʸ
   *  \return CharT ʸ֤
   */
  template < typename CharT >
    inline CharT widen( char ch )
  {
    return std::use_facet< std::ctype< CharT > >( std::locale() ).widen( ch );
  }

  template <>
    inline char widen< char >( char ch )
  {
    return ch;
  }

  template <>
    inline unsigned char widen< unsigned char >( char ch )
  {
    return static_cast< unsigned char >( ch );
  }

  template <>
    inline wchar_t widen< wchar_t >( char ch )
  {
#if defined( __MINGW32__ )
    wchar_t wc = wchar_t( -1 );
    if ( std::mbtowc( &wc, &ch, 1 ) < 0 )
    {
      return WEOF;
    }
    return wc;
#elif defined( __CYGWIN__ )
    return static_cast< wchar_t >( static_cast< unsigned char >( ch ) );
#else
    return static_cast< wchar_t >( std::btowc( static_cast< unsigned char >( ch ) ) );
#endif
  }

  /*!
   *  \brief  󥰥Хʸ󤫤 CharT ʸؤѴ
   *  \param  str   󥰥Хʸ
   *  \return CharT ʸ֤
   */
  template < typename CharT >
    std::basic_string< CharT > const widen( std::string const& str );

  template <>
    inline std::basic_string< char > const widen( std::string const& str )
  {
    return str;
  }

  template <>
    inline std::basic_string< wchar_t > const widen( std::string const& str )
  {
    boost::scoped_array< wchar_t > t( new wchar_t[str.size()+1] );
    if ( std::mbstowcs( t.get(), str.c_str(), str.size() ) == size_t( -1 ) )
    {
      static conversion_error x( "in function widen" );
      throw x;
    }
    return t.get();
  }

#undef  tolower

  /*!
   *  \brief  ʸؤѴ
   *  \param  ch    Ѵоݤʸ
   *  \return ch ʸǤб뾮ʸ򡢤ʳ ch ֤
   */
  inline char tolower( char ch )
  {
    return static_cast< char >( std::tolower( static_cast< unsigned char >( ch ) ) );
  }

  /*!
   *  \brief  ʸʸѴ
   *  \param  str   Ѵоݤʸ
   *  \return str ˴ޤޤʸʸѴʸ֤
   */
  inline std::string const tolower( std::string str )
  {
    char ( *f )( char ) = &tolower;
    std::transform( str.begin(), str.end(), str.begin(), f );
    return str;
  }

  /*!
   *  \brief  磻ʸʸѴ
   *  \param  str   Ѵоݤʸ
   *  \return str ˴ޤޤʸʸѴ磻ʸ֤
   */
  template < class Traits, class Allocator >
    std::basic_string< wchar_t, Traits, Allocator > const tolower( std::basic_string< wchar_t, Traits, Allocator > str )
  {
  	wint_t ( *f )( wint_t ) = &towlower;
    std::transform( str.begin(), str.end(), str.begin(), f );
    return str;
  }

#undef  toupper

  /*!
   *  \brief  ʸؤѴ
   *  \param  ch    Ѵоݤʸ
   *  \return ch ʸǤбʸ򡢤ʳ ch ֤
   */
  inline char toupper( char ch )
  {
    return static_cast< char >( std::toupper( static_cast< unsigned char >( ch ) ) );
  }

  /*!
   *  \brief  ʸʸѴ
   *  \param  str   Ѵоݤʸ
   *  \return str ˴ޤޤ뾮ʸʸѴʸ֤
   */
  inline std::string const toupper( std::string str )
  {
    char ( *f )( char ) = &toupper;
    std::transform( str.begin(), str.end(), str.begin(), f );
    return str;
  }

  /*!
   *  \brief  磻ʸʸѴ
   *  \param  str   Ѵоݤʸ
   *  \return str ˴ޤޤ뾮ʸʸѴ磻ʸ֤
   */
  template < class Traits, class Allocator >
    std::basic_string< wchar_t, Traits, Allocator > const toupper( std::basic_string< wchar_t, Traits, Allocator > str )
  {
  	wint_t ( *f )( wint_t ) = &towupper;
    std::transform( str.begin(), str.end(), str.begin(), f );
    return str;
  }

#undef  isspace

  /*!
   *  \brief  Ƚ
   *  
   */
  inline bool isspace( char ch )
  {
    return std::isspace( static_cast< unsigned char >( ch ) ) != 0;
  }

  /*!
   *  \brief  ʸǶڤ줿ꥹȽ
   *  \param  first   ϤƬǰ
   *  \param  last    Ϥ뽪üǰ+1
   *  \param  ostr    ϥȥ꡼
   *  \param  pred    Ǥ֤ͤҸ
   *  \param  delim   ʸ
   *
   *  δؿ϶ [first, last) γǤ pred Ϥͤ delim
   *  Ƕڤä ostr ˽Ϥޤ\n
   *  üǤθˤ delim ϽϤ줺ǤǤδ֤ˤΤ delim 
   *  Ϥޤ
   */
  template < class InputIterator, typename CharT, class Traits, class Pred >
    void output_list( InputIterator first, InputIterator last, std::basic_ostream< CharT, Traits >& ostr, Pred pred, CharT const* delim = 0 )
  {
    if ( delim == 0 )
    {
      static CharT const null_delim[] = { 0 };
      delim = null_delim;
    }

    for ( bool f = false; first != last; ++first )
    {
      if ( f )
      {
        ostr << delim;
      }
      ostr << pred( *first );
      f = true;
    }
  }

  template < typename CharT, class Traits, class Allocator >
    std::basic_string< CharT, Traits, Allocator > trim( std::basic_string< CharT, Traits, Allocator > const& str, std::basic_string< CharT, Traits, Allocator > const& ws )
  {
    if ( str.empty() || ws.empty() )
    {
      return str;
    }
    typename std::basic_string< CharT, Traits, Allocator >::size_type first = str.find_first_not_of( ws, 0 );
    for ( typename std::basic_string< CharT, Traits, Allocator >::size_type i = str.size() - 1; i >= 0; i-- )
    {
      if ( ws.find( str[ i ] ) == ws.npos )
      {
        return str.substr( first, i );
      }
    }
    return str.substr( first );
  }

}

#endif  // ! TOPPERS_MISC_HPP_
