/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: eventflag.h 333 2009-07-17 04:13:48Z ertl-honda $
 */

/*
 *		٥ȥե饰ǽ
 */

#ifndef TOPPERS_EVENTFLAG_H
#define TOPPERS_EVENTFLAG_H

#include <queue.h>

/*
 *  ٥ȥե饰֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥν֥åζʬ
 *  WOBJINIBˤĥʥ֥ȻظηѾˤΤǡ
 *  ǽΥեɤ̤ˤʤäƤ롥
 */
typedef struct eventflag_initialization_block {
	ATR			flgatr;			/* ٥ȥե饰° */
#if TTYPE_KLOCK == P_KLOCK
	POBJLOCK	p_obj_lock;		/* åؤΥݥ */
#endif /* TTYPE_KLOCK == P_KLOCK */
	FLGPTN		iflgptn;		/* ٥ȥե饰Υӥåȥѥν */
} FLGINIB;

/*
 *  ٥ȥե饰֥å
 *
 *  ι¤ΤϡƱ֥̿Ȥδ֥åζʬWOBJCB
 *  ĥʥ֥ȻظηѾˤΤǡǽ2Ĥ
 *  եɤ̤ˤʤäƤ롥
 */
typedef struct eventflag_control_block {
	QUEUE		wait_queue;		/* ٥ȥե饰Ԥ塼 */
	const FLGINIB *p_flginib;	/* ֥åؤΥݥ */
#if TTYPE_KLOCK == F_KLOCK
	OBJLOCK		obj_lock;		/* ֥ȥå */
#endif /* TTYPE_KLOCK == F_KLOCK */
	FLGPTN		flgptn;			/* ٥ȥե饰ߥѥ */
} FLGCB;

/*
 *  ٥ȥե饰IDκ͡kernel_cfg.c
 */
extern const ID	tmax_flgid;

/*
 *  ٥ȥե饰֥åΥꥢkernel_cfg.c
 */
extern const FLGINIB	flginib_table[];

/*
 *  ٥ȥե饰֥åؤΥݥ󥿥ơ֥kernel_cfg.c
 */
extern FLGCB* const		p_flgcb_table[];

/*
 *  ٥ȥե饰֥å饤٥ȥե饰IDФΥޥ
 */
#define	FLGID(p_flgcb)	((ID)(((p_flgcb->p_flginib) - flginib_table) + TMIN_FLGID))

/*
 *  ٥ȥե饰ǽν
 */
extern void	initialize_eventflag(void);

/*
 *  ٥ȥե饰ԤΥå
 */
extern bool_t	check_flg_cond(FLGCB *p_flgcb, FLGPTN waiptn,
							MODE wfmode, FLGPTN *p_flgptn);

#endif /* TOPPERS_EVENTFLAG_H */
