/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: perf_act_tsk.c 170 2009-02-25 08:27:36Z ertl-kikuchi $
 */

/*
 *  sig_sem ǽ¬ץ
 */

#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include <histogram.h>
#include "kernel_cfg.h"
#include "perf_sig_sem.h"
#include "target_test.h"

/*
 *  ¬ȼ¹ԻʬۤϿ
 */
#define NO_MEASURE	20000U			/* ¬ */
#define MAX_TIME	400000U			/* ¹ԻʬۤϿ */

/*
 *  ¹ԻʬۤϿΰ
 */
static uint_t	histarea1[MAX_TIME + 1];

/*
 *  ¬ǤΥեå롼
 */
#ifndef CPU1_PERF_PRE_HOOK
#define CPU1_PERF_PRE_HOOK
#endif  /* CPU1_PERF_PRE_HOOK */
#ifndef CPU1_PERF_POST_HOOK
#define CPU1_PERF_POST_HOOK
#endif  /* CPU1_PERF_POST_HOOK */
#ifndef CPU2_PERF_PRE_HOOK
#define CPU2_PERF_PRE_HOOK
#endif  /* CPU2_PERF_PRE_HOOK */
#ifndef CPU2_PERF_POST_HOOK
#define CPU2_PERF_POST_HOOK
#endif  /* CPU2_PERF_POST_HOOK */

void task1_1(intptr_t exinf)
{
	wai_sem(SEM1);
}

/*
 * ¬롼
 */
void perf_eval(uint_t n)
{
	uint_t	i;

	init_hist(1, MAX_TIME, histarea1);

	sus_tsk(LOGTASK1);
	dly_tsk(1000);
	CPU1_PERF_PRE_HOOK;

	for ( i = 0; i < NO_MEASURE; i++ ) {
		switch (n) {
			//Сإåɤ¬
		case 0:
			begin_measure(1);
			end_measure(1);
			break;
			//ڣۥޥեФԤ¸ߤޥե񸻿1ä롥
		case 1:
			begin_measure(1);
			sig_sem(SEM1);
			end_measure(1);
			wai_sem(SEM1);
			break;
			//ڣۥޥեФԤ¸ߤ롥sig_sem¹
			//      륿ʼ¹ԥˤƱץå˳դ
			//      Ƥꡤͥ٤ϼ¹ԥ㤤
		case 2:
			act_tsk(TASK1_1);
			chg_pri(0, HIGH_PRIORITY);
			begin_measure(1);
			sig_sem(SEM1);
			end_measure(1);
			chg_pri(0, MID_PRIORITY);
			break;
		}
	}

	CPU1_PERF_POST_HOOK;
	rsm_tsk(LOGTASK1);

	syslog(LOG_NOTICE, "==================================");
	syslog(LOG_NOTICE, "(%d)", n);
	syslog(LOG_NOTICE, "----------------------------------");
	print_hist(1);
}

/*
 *  PE1 ᥤ󥿥ͥ
 */
void main_task1(intptr_t exinf)
{
	perf_eval(0);
	perf_eval(1);
	perf_eval(2);
}
