/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: start.S 30 2008-12-14 17:03:08Z ertl-honda $
 */

/*
 *   ͥѤΥȥåץ⥸塼(ARM)
 */
#define    TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc"

/*
 *  ƱѤΥޥåʥС
 */
#define MAGIC_START 0x87654321

    .text
    .code 32
    .align  2
    .global start
start:
    /*
     *  ץå⡼ɤν
     *  ѡХ⡼ɡFIQ/IRQػ
     */
    msr  cpsr, #(CPSR_SVC|CPSR_INTLOCK) 

    /*
     *  åݥ󥿤ȡե졼ݥ󥿤ν
     *  sl(å¥쥸r10)ꤹɬפ뤫?
     *  gccϥǥեȤǤ-mapcsʤΤɬפʤ
     */
    my_istkpt sp, r0   /* FMP */
    mov  fp, #0        /* ARM⡼ѥե졼ݥ(r11) */
    mov  r7, #0        /* Thumb⡼ѥե졼ݥ    */

    /*
     *  hardware_init_hookθƤӽФ 0Ǥʤ
     *
     *  åȥϡɥ˰¸ɬפʽ
     *  ϡhardware_init_hook ȤؿѰդ
     */
    ldr   r0, =hardware_init_hook
    cmp   r0, #0x00
    movne lr, pc
    movne pc, r0

    /*
     *  0ʳϽԤ
     */
    my_core_index r0
    cmp  r0, #0
    bne  slave_wait

    /*
     *  0ѿ
     */
    ldr  r0, =start_sync
    mov  r1, #0
    str  r1,[r0]

    /*
     * ѥν롼ƤӽФ
     */
    b __cs3_reset


    /*
     *  software_init_hook ƽФ0 Ǥʤ
     *
     *  եȥĶä˥饤֥ˤ˰¸ɬפʽ
     *  ϡsoftware_init_hook ȤؿѰդ
     *  褤
     */
    .global start_master
start_master:
    ldr   r0, =software_init_hook
    cmp   r0, #0x00
    movne lr, pc
    movne pc, r0

    /*
     *  target_mprc_initalize θƤӽФ
     *
     *  sta_ker ˥ޥץåΤߤǹԤɬפΤ¹
     */
start_6:
    bl   target_mprc_initialize

    /*
     *  ͥư
     */
start_7:
    ldr  r0, =start_sync
    ldr  r1, =MAGIC_START
    str  r1, [r0]
    bl   sta_ker

    /*
     *  0ʳνԤ롼
     */
slave_wait:
    ldr  r0, =start_sync
slave_wait_1:
    ldr  r2, =MAGIC_START
    ldr  r1, [r0]
    cmp  r1, r2
    bne  slave_wait_1
    bl   sta_ker
