/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel    
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN    
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: ns16550.c 91 2009-01-25 16:50:43Z ertl-honda $
 */

/*
 *     ST16C2550  ʰSIOɥ饤
 */

#include <sil.h>
#include "target_syssvc.h"
#include "ns16550.h"

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND	1U		/* ǽХå */
#define SIO_RDY_RCV	2U		/* ΥХå */

/*
 * ƥ쥸Υեå
 */
#define NS16550_RHR   0x00   /* B  LCR bit7=0 Read  */
#define NS16550_THR   0x00   /* B  LCR bit7=0 Write */
#define NS16550_DLL   0x00   /* B  LCR bit7=1       */
#define NS16550_IER   0x04   /* B  LCR bit7=0       */
#define NS16550_DLM   0x04   /* B  LCR bit7=1       */
#define NS16550_IIR   0x08   /* B  Read  */
#define	NS16550_LCR   0x0c   /* B  */
#define NS16550_MCR   0x10   /* B  */
#define NS16550_LSR   0x14   /* B  Read */
#define NS16550_MSR   0x18   /* B  Read */
#define NS16550_SCR   0x1c   /* B  */
#define NS16550_FCR   0x20   /* B  Write */

#define IIR_TX            0x02       /* ȯ */
#define IER_TX            0x02       /* ߵ */
#define IIR_RX            0x01       /* ȯ */
#define IER_RX            0x01       /* ߵ */


#define LCR_DL_MODE       0x80       /* Divisor Enable */
#define LCR_VAL           0x03       /* 8bit,1stop,Noparity,No break */
#define FCR_FIFO_DISABLE  0x00
#define FCR_FIFO_ENABLE   0x01

#define LSR_RX_DATA_READY 0x01
#define LSR_TX_EMPTY      0x20


/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block {
    uint32_t reg_base;    /* 쥸Υ١ɥ쥹 */
    uint8_t  lcr_val;     /* ⡼ɥ쥸   */
    uint8_t  dlm_val;     /* ܡ졼Ⱦ̤   */
    uint8_t  dll_val;     /* ܡ졼Ȳ̤   */
    uint8_t intno;        /* ֹ */
} SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block {
    const SIOPINIB  *p_siopinib; /* ꥢI/OݡȽ֥å */
    intptr_t         exinf;      /* ĥ */
    bool_t             openflag;   /* ץѤߥե饰 */
    bool_t             sendflag;   /* ߥ֥͡ե饰 */
    bool_t             getready;   /* ʸ */
    bool_t             putready;   /* ʸǤ */
};


/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {UART0_BASE, UART0_LCR_VAL, UART0_DLM_VAL, UART0_DLL_VAL, DIC_IRQNO_UART0},
#if TNUM_SIOP > 2
    {UART1_BASE, UART1_LCR_VAL, UART1_DLM_VAL, UART1_DLL_VAL, DIC_IRQNO_UART1},
#endif /* TNUM_SIOP > 2 */
#if TNUM_SIOP > 3
    {UART2_BASE, UART1_LCR_VAL, UART1_DLM_VAL, UART1_DLL_VAL, DIC_IRQNO_UART2},
#endif /* TNUM_SIOP > 3 */
#if TNUM_SIOP > 4
    {UART3_BASE, UART1_LCR_VAL, UART1_DLM_VAL, UART1_DLL_VAL, DIC_IRQNO_UART3},
#endif /* TNUM_SIOP > 4 */
};

/*
 *  ꥢI/OݡȽ֥åμФ
 */
#define INDEX_SIOPINIB(siopid)  ((uint_t)((siopid) - 1))
#define get_siopinib(siopid)  (&(siopinib_table[INDEX_SIOPINIB(siopid)]))

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB  siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

Inline void
ns16550_write(uint32_t addr, uint32_t offset, uint8_t val)
{
    sil_wrb_mem((void*)(addr + offset),val);
}

Inline uint8_t
ns16550_read(uint32_t addr, uint32_t offset)
{
    return(sil_reb_mem((void*)(addr + offset)));
}

/*
 * ʸ?
 */ 
Inline bool_t
ns16550_getready(SIOPCB *p_siopcb)
{
    uint16_t status;

    status = ns16550_read(p_siopcb->p_siopinib->reg_base, NS16550_LSR);
    
    return((status & LSR_RX_DATA_READY));
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
ns16550_putready(SIOPCB *p_siopcb)
{
    uint16_t status;

    status = ns16550_read(p_siopcb->p_siopinib->reg_base, NS16550_LSR);
    
    return (status & LSR_TX_EMPTY);
}

/*
 *  ʸμФ
 */
Inline uint8_t
ns16550_getchar(SIOPCB *p_siopcb)
{
    return(ns16550_read(p_siopcb->p_siopinib->reg_base, NS16550_RHR));
}

/*
 *  ʸν񤭹
 */
Inline void
ns16550_putchar(SIOPCB *p_siopcb, uint8_t c)
{
    ns16550_write(p_siopcb->p_siopinib->reg_base, NS16550_THR, c);
}

/*
 *  ߵ
 */
Inline void
ns16550_enable_send(SIOPCB *p_siopcb)
{
    ns16550_write(p_siopcb->p_siopinib->reg_base, NS16550_IER,
                (ns16550_read(p_siopcb->p_siopinib->reg_base, NS16550_IER) | IER_TX));
}

/*
 *  ߶ػ
 */
Inline void
ns16550_disable_send(SIOPCB *p_siopcb)
{
    ns16550_write(p_siopcb->p_siopinib->reg_base, NS16550_IER,
                (ns16550_read(p_siopcb->p_siopinib->reg_base, NS16550_IER) & ~IER_TX));
                
}

/*
 *  ߵ
 */
Inline void
ns16550_enable_rcv(SIOPCB *p_siopcb)
{
    ns16550_write(p_siopcb->p_siopinib->reg_base, NS16550_IER,
                (ns16550_read(p_siopcb->p_siopinib->reg_base, NS16550_IER) | IER_RX));
}

/*
 *  ߶ػ
 */
Inline void
ns16550_disable_rcv(SIOPCB *p_siopcb)
{
    ns16550_write(p_siopcb->p_siopinib->reg_base, NS16550_IER,
                (ns16550_read(p_siopcb->p_siopinib->reg_base, NS16550_IER) & ~IER_RX));
                
}

/*
 *  SIOɥ饤Фν롼
 */
void
ns16550_initialize()
{
    SIOPCB  *p_siopcb;
    uint_t  i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->p_siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }    
}

    
/*
 * SIOPINIBν
 */
void
ns16550_init_siopinib(const SIOPINIB *p_siopinib)
{
    /*
     *  ʬ
     */
    /* Divisor Enable */
    ns16550_write(p_siopinib->reg_base, NS16550_LCR,
                (ns16550_read(p_siopinib->reg_base, NS16550_LCR) | LCR_DL_MODE));
    ns16550_write(p_siopinib->reg_base, NS16550_DLL, p_siopinib->dll_val);
    ns16550_write(p_siopinib->reg_base, NS16550_DLM, p_siopinib->dlm_val);

    /* Divisor Disable */
    ns16550_write(p_siopinib->reg_base, NS16550_LCR,
                (ns16550_read(p_siopinib->reg_base, NS16550_LCR) & ~LCR_DL_MODE));

    /* ⡼ */
    ns16550_write(p_siopinib->reg_base, NS16550_LCR, p_siopinib->lcr_val);

    /* FIFO Disable */
    ns16550_write(p_siopinib->reg_base, NS16550_FCR, FCR_FIFO_DISABLE);

    /* ߶ػ */
    ns16550_write(p_siopinib->reg_base, NS16550_IER, 0x00);
}


/*
 * ץ󤷤ƤݡȤ뤫?
 */
bool_t
ns16550_openflag(ID siopid)
{
	SIOPCB          *p_siopcb;

	p_siopcb = get_siopcb(siopid);

	return(p_siopcb->openflag);
}


/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
ns16550_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB      *p_siopcb;
    const SIOPINIB  *p_siopinib;

    p_siopcb = get_siopcb(siopid);
    p_siopinib = p_siopcb->p_siopinib;
    
    /*
     * 
     */
    ns16550_init_siopinib(p_siopcb->p_siopinib);
    
    /* ߶ػ */
    ns16550_enable_rcv(p_siopcb);
    /* ߶ػ */
    ns16550_disable_rcv(p_siopcb);
    
    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
ns16550_cls_por(SIOPCB *p_siopcb)
{
    /* ߶ػ */
    ns16550_write(p_siopcb->p_siopinib->reg_base, NS16550_IER, 0x00);   
    p_siopcb->openflag = false;
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
ns16550_snd_chr(SIOPCB *p_siopcb, char_t c)
{
    if (ns16550_putready(p_siopcb)){
        ns16550_putchar(p_siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int
ns16550_rcv_chr(SIOPCB *p_siopcb)
{
    if (ns16550_getready(p_siopcb)) {
        return((int)(uint8_t)ns16550_getchar(p_siopcb));
    }
    return(-1);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
ns16550_ena_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            ns16550_enable_send(p_siopcb);
            break;
        case SIO_RDY_RCV:
            ns16550_enable_rcv(p_siopcb);
            break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
ns16550_dis_cbr(SIOPCB *p_siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            ns16550_disable_send(p_siopcb);
            break;
        case SIO_RDY_RCV:
            ns16550_disable_rcv(p_siopcb);
            break;
    }
}

/*
 *  ꥢI/OݡȤФ߽
 */
static void
ns16550_isr_siop(SIOPCB *p_siopcb)
{
    if (ns16550_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        ns16550_irdy_rcv(p_siopcb->exinf);
    }
    if (ns16550_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        ns16550_irdy_snd(p_siopcb->exinf);
    }
}

/*
 *  SIOγߥӥ롼
 */
void
ns16550_isr(intptr_t exinf)
{
    ns16550_isr_siop(get_siopcb(exinf));
}

/*
 *  SIOPCBؤΥݥ󥿤ݡֹ֤
 */
ID
ns16550_get_siopid(SIOPCB *p_siopcb)
{
	return (ID)((p_siopcb - siopcb_table) + 1);
}

/*
 *  ֹ֤
 */
uint8_t
ns16550_get_intno(SIOPCB *p_siopcb)
{
	return p_siopcb->p_siopinib->intno;
}
