/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mact_tsk1.c 16 2008-12-08 06:15:08Z ertl-honda $
 */

/* 
 *		ԥåӥΥƥ
 *  ڥƥȤŪ
 *    ԥåӥ뤬ưƤ뤫å롥
 *
 *  ڥƥȹܡ
 *    APIμˤʬԤ
 *
 *    (1) loc_spnˤ륿֤¾
 *    (2) try_spnˤ륿֤¾
 *    (3) iloc_spnˤ륢顼ϥɥ֤¾
 *    (4) itry_spnˤ륢顼ϥɥ֤¾
 *    (5) loc_spniloc_spnˤ륿ȥ顼ϥɥ֤¾
 *    (6) try_spnitry_spnˤ륿ȥ顼ϥɥ֤¾  
 */


#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "test_lib.h"

#define LOOP_REF 10000
#define BUSY_LOOP_REF 1000

volatile int32_t global_data;

/*
 *  16bitΥ󥯥
 */
int32_t
inc_data_upper(int32_t data)
{
	uint_t i;

	for (i = 0; i < BUSY_LOOP_REF; i++);
	return data + 0x10000;
}

/*
 *  6bitΥ󥯥
 */
int32_t
inc_data_lower(int32_t data)
{
	uint_t i;

	for (i = 0; i < BUSY_LOOP_REF; i++);
	return data + 0x0001;
}

/*
 *  PE1ưƥȤΥᥤ󥿥
 */
void
task1_1(intptr_t exinf)
{
	ER	ercd;
	uint_t  i;

	check_point(1);

	/*
	 * (1) loc_spnˤ륿֤¾
	 */
	global_data = 0;
	ercd = act_tsk(TASK2_1);
	check_ercd(ercd, E_OK);

	barrier_sync(1);

	for(i = 0; i < LOOP_REF; i++) {
		ercd = loc_spn(SPN1);
		check_ercd(ercd, E_OK);
		global_data = inc_data_upper(global_data);
		ercd = unl_spn(SPN1);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff0000) == (LOOP_REF << 16));

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(2);

	/*
	 * (2) try_spnˤ륿֤¾
	 */
	global_data = 0;
	ercd = act_tsk(TASK2_2);
	check_ercd(ercd, E_OK);

	barrier_sync(2);

	for(i = 0; i < LOOP_REF; i++) {
		do {
			ercd = try_spn(SPN1);
		}while(ercd == E_OBJ);
		check_ercd(ercd, E_OK);
		global_data = inc_data_upper(global_data);
		ercd = unl_spn(SPN1);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff0000) == (LOOP_REF << 16));

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(3);

	/*
	 * (3) iloc_spnˤ륢顼ϥɥ֤¾
	 */
	global_data = 0;
	ercd = sta_alm(ALMHDR2_1, 1);
	check_ercd(ercd, E_OK);

	check_point(4);
	ercd = sta_alm(ALMHDR1_1, 1);
	check_ercd(ercd, E_OK);

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(7);

	/*
	 * (4) itry_spnˤ륢顼ϥɥ֤¾
	 */
	global_data = 0;
	ercd = sta_alm(ALMHDR2_2, 1);
	check_ercd(ercd, E_OK);

	check_point(8);
	ercd = sta_alm(ALMHDR1_2, 1);
	check_ercd(ercd, E_OK);

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(11);

	/*
	 * (5) loc_spniloc_spnˤ륿ȥ顼ϥɥ֤¾
	 */
	global_data = 0;
	ercd = sta_alm(ALMHDR2_3, 1);
	check_ercd(ercd, E_OK);

	barrier_sync(5);

	for(i = 0; i < LOOP_REF; i++) {
		ercd = loc_spn(SPN1);
		check_ercd(ercd, E_OK);
		global_data = inc_data_upper(global_data);
		ercd = unl_spn(SPN1);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff0000) == (LOOP_REF << 16));

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(12);

	/*
	 * (6) try_spnitry_spnˤ륿ȥ顼ϥɥ֤¾
	 */
	global_data = 0;
	ercd = sta_alm(ALMHDR2_4, 11);
	check_ercd(ercd, E_OK);

	barrier_sync(6);

	for(i = 0; i < LOOP_REF; i++) {
		do {
			ercd = try_spn(SPN2);
		} while(ercd == E_OBJ);
		check_ercd(ercd, E_OK);
		global_data = inc_data_upper(global_data);
		ercd = unl_spn(SPN2);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff0000) == (LOOP_REF << 16));

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_finish(13);
}

/*
 * (1) loc_spnˤ륿֤¾ѤΥ
 */
void
task2_1(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(1);
	barrier_sync(1);

	for(i = 0; i < LOOP_REF; i++) {
		ercd = loc_spn(SPN1);
		check_ercd(ercd, E_OK);
		global_data = inc_data_lower(global_data);
		ercd = unl_spn(SPN1);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff) == LOOP_REF);

	ercd = wup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_point(2);
}

/*
 * (2) try_spnˤ륿֤¾ѤΥ
 */
void
task2_2(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(3);
	barrier_sync(2);

	for(i = 0; i < LOOP_REF; i++) {
		do {
			ercd = try_spn(SPN1);
		} while(ercd == E_OBJ);
		check_ercd(ercd, E_OK);
		global_data = inc_data_lower(global_data);
		ercd = unl_spn(SPN1);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff) == LOOP_REF);

	ercd = wup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_point(4);
}

/*
 * (3) iloc_spnˤ륢顼ϥɥ֤¾
 */
void
alarm_handler1_1(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(5);
	barrier_sync(3);

	for(i = 0; i < LOOP_REF; i++) {
		ercd = iloc_spn(SPN2);
		check_ercd(ercd, E_OK);
		global_data = inc_data_upper(global_data);
		ercd = iunl_spn(SPN2);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff0000) == (LOOP_REF << 16));

	ercd = iwup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_point(6);
}

void
alarm_handler2_1(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(5);

	barrier_sync(3);

	for(i = 0; i < LOOP_REF; i++) {
		ercd = iloc_spn(SPN2);
		check_ercd(ercd, E_OK);
		global_data = inc_data_lower(global_data);
		ercd = iunl_spn(SPN2);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff) == LOOP_REF);

	ercd = iwup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_point(6);
}

/*
 * (4) itry_spnˤ륢顼ϥɥ֤¾
 */
void
alarm_handler1_2(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(9);
	barrier_sync(4);

	for(i = 0; i < LOOP_REF; i++) {
		do {
			ercd = itry_spn(SPN2);
		} while(ercd == E_OBJ);
		check_ercd(ercd, E_OK);
		global_data = inc_data_upper(global_data);
		ercd = iunl_spn(SPN2);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff0000) == (LOOP_REF << 16));

	ercd = iwup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_point(10);
}

void
alarm_handler2_2(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(7);

	barrier_sync(4);

	for(i = 0; i < LOOP_REF; i++) {
		do {
			ercd = itry_spn(SPN2);
		} while(ercd == E_OBJ);
		check_ercd(ercd, E_OK);
		global_data = inc_data_lower(global_data);
		ercd = iunl_spn(SPN2);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff) == LOOP_REF);

	ercd = iwup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_point(8);
}

/*
 * (5) loc_spniloc_spnˤ륿ȥ顼ϥɥ֤¾
 */
void
alarm_handler2_3(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(9);
	barrier_sync(5);

	for(i = 0; i < LOOP_REF; i++) {
		ercd = iloc_spn(SPN1);
		check_ercd(ercd, E_OK);
		global_data = inc_data_lower(global_data);
		ercd = iunl_spn(SPN1);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff) == LOOP_REF);

	ercd = iwup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_point(10);
}

/*
 * (6) try_spnitry_spnˤ륿ȥ顼ϥɥ֤¾
 */
void
alarm_handler2_4(intptr_t exinf)
{
	ER	ercd;
	uint_t i;

	check_point(11);
	barrier_sync(6);

	for(i = 0; i < LOOP_REF; i++) {
		do {
			ercd = itry_spn(SPN2);
		} while(ercd == E_OBJ);
		check_ercd(ercd, E_OK);
		global_data = inc_data_lower(global_data);
		ercd = iunl_spn(SPN2);
		check_ercd(ercd, E_OK);
	}

	check_assert((global_data & 0xffff) == LOOP_REF);

	ercd = iwup_tsk(TASK1_1);
	check_ercd(ercd, E_OK);

	check_finish(12);
}
